﻿/*
      Copyright (C) 2010 Bepu Entertainment LLC.

      This software source code is provided 'as-is', without 
      any express or implied warranty.  In no event will the authors be held 
      liable for any damages arising from the use of this software.

      Permission is granted to anyone to use this software for any purpose,
      including commercial applications, and to alter it and redistribute it
      freely, subject to the following restrictions:

      1. The origin of this software must not be misrepresented; you must not
         claim that you wrote the original software. If you use this software
         in a product, an acknowledgment in the product documentation would be
         appreciated but is not required.
      2. Altered source versions must be plainly marked as such, and must not be
         misrepresented as being the original software.
      3. This notice may not be removed or altered from any source distribution.

    Contact us at:
    contact@bepu-games.com
 */


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BEPUphysicsDrawer.Models
{
    /// <summary>
    /// Contains some information about a ModelDisplayObject's batch.
    /// </summary>
    public class BatchInformation
    {   
        /// <summary>
        /// Batch that a display object belongs to.
        /// </summary>
        public ModelDisplayObjectBatch batch;
        /// <summary>
        /// Index in the batch's vertex buffer where this display object's vertices start.
        /// </summary>
        public int baseVertexBufferIndex = 0;
        /// <summary>
        /// Index in the batch's index buffer where this display object's vertices start.
        /// </summary>
        public int baseIndexBufferIndex = 0;
        /// <summary>
        /// Index in the batch's display object list where this display object will be inserted.
        /// </summary>
        public int batchListIndex = 0;
        /// <summary>
        /// Number of vertices in the display object.
        /// </summary>
        public int vertexCount = 0;
        /// <summary>
        /// Number of indices in the display object.
        /// </summary>
        public int indexCount = 0;
    }
}
